TeVeO/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('TeVeOApp.urls')),
]

TeVeOApp/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.pagina_principal, name='pagina_principal'),
    path('configuracion/', views.pagina_configuracion, name='pagina_configuracion'),
    path('ayuda/', views.pagina_ayuda, name='pagina_ayuda'),
    path('cerrar_sesion/', views.cerrar_sesion, name='cerrar_sesion'),
    path('camaras/', views.pagina_camaras, name='pagina_camaras'),
    path('camara/<str:id_camara>/', views.pagina_camara, name='pagina_camara'),
    path('camara/json/<str:id_camara>/', views.pagina_camara_json, name='pagina_camara_json'),
    path('camara/<str:id_camara>/comentario/', views.pagina_comentario, name='pagina_comentario'),
    path('camara/dyn/<str:id_camara>/', views.pagina_camara_dinamica, name='pagina_camara_dinamica'),
    path('camara/dyn/<str:id_camara>/image', views.descargar_y_devolver_imagen, name='descargar_y_devolver_imagen'),

]

TeVeOApp/models.py
from django.db import models
from django.conf import settings


class ConfiguracionUsuario(models.Model):
    nombre_usuario = models.CharField(max_length=100, default='Anónimo')
    tamano_fuente = models.CharField(max_length=20, default='medium')
    tipo_fuente = models.CharField(max_length=50, default='Arial')

    def __str__(self):
        return self.nombre_usuario, self.tamano_fuente, self.tipo_fuente


class Camara(models.Model):
    id_camara = models.CharField(max_length=50)
    nombre = models.CharField(max_length=100)
    coordenadas = models.CharField(max_length=100)  # Puede ser una combinación de longitud y latitud.(listado2.xml)
    src = models.URLField()  # URL de la imagen o del stream de la cámara.

    def __str__(self):
        return self.nombre


class Comentario(models.Model):
    camara = models.ForeignKey(Camara, on_delete=models.CASCADE)
    usuario = models.ForeignKey(ConfiguracionUsuario, on_delete=models.CASCADE)
    texto = models.TextField()
    fecha = models.DateTimeField()
    imagen_url = models.FilePathField(path=f'{settings.BASE_DIR}/imagen_comentarios/', blank=False)

    def __str__(self):
        return f"Comentario por {self.camara} en {self.fecha}"

TeVeOApp/forms.py
from django import forms
from .models import ConfiguracionUsuario, Comentario


class UserSetupForm(forms.ModelForm):
    TIPO_FUENTE_CHOICES = [
        ('Arial', 'Arial'),
        ('Verdana', 'Verdana'),
        ('Times New Roman', 'Times New Roman')
    ]

    TAMANO_FUENTE_CHOICES = [
        ('x-small', 'Pequeño'),
        ('medium', 'Mediano'),
        ('x-large', 'Grande')
    ]

    tipo_fuente = forms.ChoiceField(choices=TIPO_FUENTE_CHOICES, label="Tipo de Fuente")
    tamano_fuente = forms.ChoiceField(choices=TAMANO_FUENTE_CHOICES, label="Tamaño de Fuente")

    class Meta:
        model = ConfiguracionUsuario
        fields = ['nombre_usuario', 'tipo_fuente', 'tamano_fuente']


class ComentarioForm(forms.ModelForm):
    class Meta:
        model = Comentario
        fields = ['texto']

TeVeOApp/views.py
import base64
import os.path
import os

from django.contrib.sites import requests
from django.core.paginator import Paginator
from django.conf import settings
from django.utils import timezone
from .models import Comentario, Camara, ConfiguracionUsuario
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponse, JsonResponse
from datetime import datetime
import xml.etree.ElementTree as ET
import urllib.request
from .forms import UserSetupForm, ComentarioForm
import random
from django.db.models import Count
import requests
import pytz




# -------------------------------------------------------------------------------------------------------------

def cerrar_sesion(request):
    request.session.flush()
    return redirect('pagina_principal')


# -------------------------------------------------------------------------------------------------------------

def pagina_ayuda(request):
    return render(request, 'pagina_ayuda.html')


# -------------------------------------------------------------------------------------------------------------

def pagina_configuracion(request):
    if request.method == 'POST':
        form = UserSetupForm(request.POST)
        if form.is_valid():
            user_setup = form.save(commit=False)
            request.session['nombre_usuario'] = user_setup.nombre_usuario
            request.session['tamano_fuente'] = user_setup.tamano_fuente
            request.session['tipo_fuente'] = user_setup.tipo_fuente

            # Crear o actualizar ConfiguracionUsuario
            ConfiguracionUsuario.objects.update_or_create(
                nombre_usuario=user_setup.nombre_usuario,
                defaults={
                    'tamano_fuente': user_setup.tamano_fuente,
                    'tipo_fuente': user_setup.tipo_fuente
                }
            )

            return redirect('pagina_principal')
    else:
        initial_data = {
            'nombre_usuario': request.session.get('nombre_usuario', 'Anónimo'),
            'tamano_fuente': request.session.get('tamano_fuente', 'Mediana'),
            'tipo_fuente': request.session.get('tipo_fuente', 'Arial'),
        }
        form = UserSetupForm(initial=initial_data)

    return render(request, 'pagina_configuracion.html', {'form': form})


# -------------------------------------------------------------------------------------------------------------#
def pagina_principal(request):
    comentarios_list = Comentario.objects.all().order_by('-fecha')
    paginator = Paginator(comentarios_list, 5)  # 5 comentarios por página

    page_number = request.GET.get('page')
    comentario = paginator.get_page(page_number)

    total_camaras = Camara.objects.count()
    total_comentarios = Comentario.objects.count()

    context = {
        'comentario': comentario,
        'total_camaras': total_camaras,
        'total_comentarios': total_comentarios
    }

    return render(request, 'pagina_principal.html', context)


# -------------------------------------------------------------------------------------------------------------
def descargar_bases_datos(base_datos):
    if base_datos == 'listado1.xml':
        url = 'https://gitlab.eif.urjc.es/cursosweb/2023-2024/final-teveo/-/raw/main/listado1.xml'
    elif base_datos == 'listado2.xml':
        url = 'https://gitlab.eif.urjc.es/cursosweb/2023-2024/final-teveo/-/raw/main/listado2.xml'
    elif base_datos == 'listadoextra.xml':
        url = 'https://infocar.dgt.es/datex2/dgt/CCTVSiteTablePublication/all/content.xml'
    elif base_datos == 'listadoextra2.xml':
        url = 'https://opendata.euskadi.eus/contenidos/ds_localizaciones/camaras_trafico/opendata/camaras-trafico.xml'

    # Descarga el archivo XML
    response = urllib.request.urlopen(url)
    data = response.read().decode('utf-8')
    # Procesa el XML y almacena la información en la base de datos
    root = ET.fromstring(data)

    for camara in root.findall('camara'):
        if base_datos == 'listado1.xml':
            id = camara.find('id').text
            id = 'LIS1-' + id
            src = camara.find('src').text
            lugar = camara.find('lugar').text
            coordenadas = camara.find('coordenadas').text
            # Verifica si la cámara ya existe en la base de datos antes de guardarla
            if not Camara.objects.filter(id_camara=id).exists():
                Camara.objects.create(id_camara=id,
                                      src=src,
                                      nombre=lugar,
                                      coordenadas=coordenadas)
    for cam in root.findall('cam'):
        if base_datos == 'listado2.xml':
            id = cam.get('id')
            id = 'LIS2-' + id
            url = cam.find('url').text
            info = cam.find('info').text
            latitude = cam.find('place/latitude').text
            longitude = cam.find('place/longitude').text
            coordenadas = latitude + ',' + longitude

            if not Camara.objects.filter(id_camara=id).exists():
                Camara.objects.create(id_camara=id,
                                      src=url,
                                      nombre=info,
                                      coordenadas=coordenadas)

    if root.tag.endswith('d2LogicalModel'):
        i = 0
        for cam in root.findall('.//_0:cctvCameraMetadataRecord',
                              namespaces={'_0': 'http://datex2.eu/schema/2/2_0'}):
                i += 1
                id = "LIS3-" + str(i)
                info = cam.find('_0:cctvCameraIdentification',
                                           namespaces={'_0': 'http://datex2.eu/schema/2/2_0'}).text
                url = cam.find('.//_0:urlLinkAddress',
                                          namespaces={'_0': 'http://datex2.eu/schema/2/2_0'}).text
                cam_latitude = cam.find('.//_0:latitude',
                                               namespaces={'_0': 'http://datex2.eu/schema/2/2_0'}).text
                cam_longitude = cam.find('.//_0:longitude',
                                                namespaces={'_0': 'http://datex2.eu/schema/2/2_0'}).text
                coordenadas = "{},{}".format(cam_latitude, cam_longitude)


                if not Camara.objects.filter(id_camara=id).exists():
                    Camara.objects.create(id_camara=id,
                                          src=url,
                                          nombre=info,
                                          coordenadas=coordenadas)

    for cam in root.findall('row'):
        if base_datos == 'listadoextra2.xml':
            id = cam.get('num')
            id = 'LIS4-' + id
            url = cam.find('urlcam').text
            info = cam.find('title').text
            latitude = cam.find('latwgs84').text
            longitude = cam.find('lonwgs84').text
            coordenadas = latitude + ',' + longitude

            if not Camara.objects.filter(id_camara=id).exists():
                Camara.objects.create(id_camara=id,
                                      src=url,
                                      nombre=info,
                                      coordenadas=coordenadas)





# -------------------------------------------------------------------------------------------------------------

def pagina_camaras(request):
    bases = {
        'listado1.xml': 'Listado 1',
        'listado2.xml': 'Listado 2',
        'listadoextra.xml': 'Listado extra(DGT)',
        'listadoextra2.xml': 'Listado extra 2(Euskadi)'

    }

    if request.method == 'POST':
        base_datos = request.POST.get('base_datos')
        descargar_bases_datos(base_datos)

    camaras = Camara.objects.all().annotate(total_comentarios=Count('comentario')).order_by('-total_comentarios')
    # Configurar el paginador para mostrar 4 camaras por página
    paginator = Paginator(camaras, 4)
    page_number = request.GET.get('page')
    cameras = paginator.get_page(page_number)
    if cameras:
        camara_aleatoria = random.choice(cameras)
    else:
        camara_aleatoria = None

    context = {
        'bases': bases,
        'cameras': cameras,
        'camara_aleatoria': camara_aleatoria,
    }

    return render(request, 'pagina_camaras.html', context)


# -------------------------------------------------------------------------------------------------------------


def pagina_camara(request, id_camara):
    camara = get_object_or_404(Camara, id_camara=id_camara)
    comentarios_list = Comentario.objects.filter(camara=camara).order_by('-fecha')

    # Configurar el paginador para mostrar 5 comentarios por página
    paginator = Paginator(comentarios_list, 5)
    page_number = request.GET.get('page')
    comentarios = paginator.get_page(page_number)

    context = {
        'camara': camara,
        'comentarios': comentarios,
    }
    return render(request, 'pagina_camara.html', context)


# -------------------------------------------------------------------------------------------------------------

def descargar_y_devolver_imagen(request, id_camara):
    camara = get_object_or_404(Camara, id_camara=id_camara)
    url_imagen = camara.src
    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:100.0) Gecko/20100101 Firefox/100.0'
    }

    try:
        response = requests.get(url_imagen, headers=headers)
        response.raise_for_status()
        image_base64 = base64.b64encode(response.content).decode('utf-8')
        html = f'<img src="data:image/jpeg;base64,{image_base64}" class="card-img-top" alt="Camera Image" style="width:100%; height:auto;">'
        return HttpResponse(html, content_type="text/html")
    except requests.RequestException as e:
        return HttpResponse(str(e), status=500)


def pagina_camara_dinamica(request, id_camara):
    camara = get_object_or_404(Camara, id_camara=id_camara)
    comentarios = Comentario.objects.filter(camara=camara).order_by('-fecha')

    context = {

TeVeOApp/templates/base.html
<!DOCTYPE html>
<html>
<head>
    <title>TeVeO - {% block title %}{% endblock %}</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootswatch@4.5.2/dist/minty/bootstrap.min.css" integrity="sha384-H4X+4tKc7b8s4GoMrylmy2ssQYpDHoqzPa9aKXbDwPoPUA3Ra8PA5dGzijN+ePnH" crossorigin="anonymous">
    <style>
        body {
            font-size: {{ tamano_fuente }} ;
            font-family: {{ tipo_fuente }} ;
        }
    </style>
    {% load static %}
    <link href="{% static 'styles.css' %}" rel="stylesheet">

    <script src="https://unpkg.com/htmx.org@1.9.10"></script>

    {% load static %}
    <link rel="icon" href="{% static 'favicon.ico' %}">


</head>
<body>
    <header>
        <div class="row border container-fluid">
            <div class=" subtitulo col-3">
                <img src="{% static 'teveo.png' %}" alt="TeVeO" style="width: 80%; height: auto;">
            </div>
            <div class="col-9">
                <nav>
                    <div class=>
                        <p class="indice"><a href="{% url 'pagina_principal' %}">|  Pagina Principal  |</a>
                        <a href="{% url 'pagina_camaras' %}">  Camaras  |</a>
                        <a href="{% url 'pagina_configuracion' %}">  Configuración  |</a>
                        <a href="{% url 'pagina_ayuda' %}">  Ayuda  |</a>
                        <a href="/admin"> Admin  |</a>
                        <a href="{% url 'cerrar_sesion' %}">  Cerrar Sesion  |</a></p>
                    </div>
                </nav>
                <h3>Bienvenido, {{ nombre_usuario }}</h3>
                <h3>Te encuentras en {% block subtitle %}{% endblock %}</h3>
            </div>
        </div>

    </header>

    <main>
        {% block content %}{% endblock %}
    </main>

    <footer>
        <br><br><p>Cámaras: {{ total_camaras }}.<br> Comentarios: {{ total_comentarios }}.</p>
    </footer>
</body>
</html>

TeVeOApp/templates/pagina_ayuda.html
{% extends "base.html" %}
{% load static %}

{% block title %}Ayuda - TeVeO{% endblock %}
{% block subtitle %}la Página de Ayuda{% endblock %}

{% block content %}
    <h1>Ayuda - TeVeO</h1>
    <p>Autoría de la práctica: Jose Carlos Hernandez Gajardo</p>
    <h2>Funcionamiento de TeVeO</h2>
    <p>TeVeO es una aplicación web que permite comentar lo que se ve en ciertas cámaras. La información de las cámaras
        se obtiene automáticamente de diversas fuentes de datos y los usuarios pueden dejar comentarios sobre lo que
        ven en estas cámaras.</p>
    <h2>Documentación</h2>
    <p>Para obtener más información sobre cómo utilizar TeVeO, consulta la documentación proporcionada con la práctica
        o visita el sitio web oficial de TeVeO.</p>
{% endblock %}

TeVeOApp/templates/pagina_camara.html
{% extends 'base.html' %}
{% load static %}

{% block subtitle %}la Página de las Camaras{% endblock %}


{% block title %}Camara - {{ camara.nombre }}{% endblock %}

{% block content %}
    <br><div class="row border container-fluid justify-content-center">
        <div class="col-4">
            <h2 class="subtitulo">Detalles de la Cámara</h2>
            <p><strong>Nombre:</strong> {{ camara.nombre }}</p>
            <p><strong>Coordenadas:</strong> {{ camara.coordenadas }}</p>
            <a class="bg-success text-white" href="/camara/dyn/{{ camara.id_camara }}/">Enlace a la página dinámica de {{ camara.nombre }}</a><br>
            <a class="bg-success text-white" href="/camara/json/{{ camara.id_camara }}/">Enlace a la página json de {{ camara.nombre }}</a><br><br>
            <img src="{{ camara.src }}" alt="{{ camara.nombre }}" width="480"><br><br>
            <a class="btn btn-success" href="/camara/{{ camara.id_camara }}/comentario/">Añadir comentario a la página de {{ camara.nombre }}</a>
        </div>
        <div class="col-1"></div>
        <div class="col-6">
             <h3 class="subtitulo">Comentarios Recientes</h3>
                {% if comentarios %}
                        {% for comentario in comentarios %}
                            <br><div class="row container-fluid">
                                <div class="card border-success mb-5 col-4">
                                    <br><p class="card-text"><strong>Comentario:</strong><br> {{ comentario.texto }}</p>
                                </div>
                                <div class="col-3">
                                    <br><p><strong>Autor:</strong> {{ comentario.usuario.nombre_usuario }}</p>
                                    <p><strong>Fecha:</strong> {{ comentario.fecha }}</p><br>
                                </div>
                                <div class="col-5">
                                        <img src="{% static 'imagen_comentarios/' %}{{ comentario.imagen_url }}" alt="Imagen no encontrada" style="width: 100%; height: auto;">
                                </div>
                            </div>

                        {% endfor %}

            <div class="pagination">
                <span class="step-links">
                    {% if comentarios.has_previous %}
                        <a href="?page=1">&laquo; primero</a>
                        <a href="?page={{ comentarios.previous_page_number }}">anterior</a>
                    {% endif %}

                    <span class="current">
                        Página {{ comentarios.number }} de {{ comentarios.paginator.num_pages }}.
                    </span>

                    {% if comentarios.has_next %}
                        <a href="?page={{ comentarios.next_page_number }}">siguiente</a>
                        <a href="?page={{ comentarios.paginator.num_pages }}">último &raquo;</a>
                    {% endif %}
                </span>
            </div>
        {% else %}
            <p>No hay comentarios todavía para esta cámara.</p>
        {% endif %}
        </div>
    </div>
{% endblock %}

TeVeOApp/templates/pagina_camara_dinamica.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Dinamica - {{ camara.nombre }}{% endblock %}
{% block subtitle %}la Página Dinamica{% endblock %}

{% block content %}
    <br><div class="row border container-fluid justify-content-center">
        <div class="col-4">
            <br><h2>Detalles de la Cámara</h2>
            <p><strong>Nombre:</strong> {{ camara.nombre }}</p>
            <p><strong>Coordenadas:</strong> {{ camara.coordenadas }}</p>
            <a class="bg-success text-white" href="/camara/{{ camara.id_camara }}/">Enlace a la página de {{ camara.nombre }}</a><br>
            <a class="bg-success text-white" href="/camara/json/{{ camara.id_camara }}/">Enlace a la página json de {{ camara.nombre }}</a>
            <div id="camera-image" hx-get="/camara/dyn/{{ camara.id_camara }}/image" hx-trigger="load, every 30s">
                <img src="{{ camara.src }}" alt="{{ camara.nombre }}" width="480">
            </div><br>
            <a class="btn btn-success" href="/camara/{{ camara.id_camara }}/comentario/">Añadir comentario a la página de {{ camara.nombre }}</a>
        </div>

        <div class="col-1"></div>
        <div class="col-6">
             <h3 class="subtitulo">Comentarios Recientes</h3>
                {% if comentarios %}
                        {% for comentario in comentarios %}
                            <br><div class="row container-fluid">
                                <div class="card border-success mb-5 col-4">
                                    <br><p class="card-text"><strong>Comentario:</strong><br> {{ comentario.texto }}</p>
                                </div>
                                <div class="col-3">
                                    <br><p><strong>Autor:</strong> {{ comentario.usuario.nombre_usuario }}</p>
                                    <p><strong>Fecha:</strong> {{ comentario.fecha }}</p><br>
                                </div>
                                <div class="col-5">
                                        <img src="{% static 'imagen_comentarios/' %}{{ comentario.imagen_url }}" alt="Imagen no encontrada" style="width: 100%; height: auto;">
                                </div>
                            </div>

                        {% endfor %}

            <div class="pagination">
                <span class="step-links">
                    {% if comentarios.has_previous %}
                        <a href="?page=1">&laquo; primero</a>
                        <a href="?page={{ comentarios.previous_page_number }}">anterior</a>
                    {% endif %}

                    <span class="current">
                        Página {{ comentarios.number }} de {{ comentarios.paginator.num_pages }}.
                    </span>

                    {% if comentarios.has_next %}
                        <a href="?page={{ comentarios.next_page_number }}">siguiente</a>
                        <a href="?page={{ comentarios.paginator.num_pages }}">último &raquo;</a>
                    {% endif %}
                </span>
            </div>
        {% else %}
            <p>No hay comentarios todavía para esta cámara.</p>
        {% endif %}
        </div>
    </div>
{% endblock %}

TeVeOApp/templates/pagina_camaras.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Listado de Cámaras{% endblock %}
{% block subtitle %}el Listado de Cámaras{% endblock %}
{% block content %}
    <div class="row border container-fluid justify-content-center">

        <div class="col-7">

        </div>
    </div>


    <br>
        <div class="row border container-fluid justify-content-center">
            <div class="subtitulo col-4">
                <h4 >Fuentes de Datos Disponibles</h4>
                    {% for base_datos, source_name in bases.items %}
                            <form action="{% url 'pagina_camaras' %}" method="post">
                                {% csrf_token %}
                                <input type="hidden" name="base_datos" value="{{ base_datos }}">
                                {{ source_name }}: <br>
                                <button type="submit"> Descargar </button>
                            </form>
                    {% endfor %}
                <br>

                {% if camara_aleatoria %}
                <br><br><br><h4 class="subtitulo">Imagen Camara Aleatoria</h4>
                <a class="bg-success text-white" href="/camara/{{ camara_aleatoria.id_camara }}/">{{ camara_aleatoria.nombre }} </a>
                <img src="{{ camara_aleatoria.src }}" alt="{{ camara_aleatoria.nombre }}" width="500"><br><br>
                {% endif %}
            </div>
            <div class="col-1"></div>
            <div class="col-6">
                <h4 class="subtitulo">Listado de camaras disponibles</h4>
                {% for camara in cameras %}
                <p> Nombre de la camara: {{ camara.nombre }}  | Comentarios:{{ camara.total_comentarios }}</p>
                <div class="row border">
                    <div class="col-5">
                        <img src="{{ camara.src }}" alt="{{ camara.nombre }}" width="100%"><br><br>

                    </div>
                    <div class="col-7">
                        <a class="bg-success text-white" href="/camara/{{ camara.id_camara }}/">Camara de {{ camara.nombre }}</a><br><br>
                        <a class="bg-success text-white" href="/camara/dyn/{{ camara.id_camara }}/">Camara dinamica de {{ camara.nombre }}</a><br><br>
                        <a class="bg-success text-white" href="/camara/json/{{ camara.id_camara }}/">Página json de {{ camara.nombre }}</a><br><br><br>
                    </div>
                </div>
                {% endfor %}
                <div class="pagination">
                    <span class="step-links">
                        {% if cameras.has_previous %}
                            <a href="?page=1">&laquo; primera</a>
                            <a href="?page={{ cameras.previous_page_number }}">anterior</a>
                        {% endif %}

                        <span class="current">
                            Página {{ cameras.number }} de {{ cameras.paginator.num_pages }}.
                        </span>

                        {% if cameras.has_next %}
                            <a href="?page={{ cameras.next_page_number }}">siguiente</a>
                            <a href="?page={{ cameras.paginator.num_pages }}">última &raquo;</a>
                        {% endif %}
                    </span>
                </div>
            </div>
        </div>

{% endblock %}

TeVeOApp/templates/pagina_comentario.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Comentar Cámara{% endblock %}
{% block subtitle %}la pagina para comentar{% endblock %}

{% block content %}
<br><div class="row border container-fluid justify-content-center">
    <div class="col-4">
        <h1>Comentar Cámara: {{ camara.nombre }}</h1>

        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <button type="submit" class="btn btn-primary">Enviar Comentario</button>
        </form>
    </div>
    <div class="col-4">
        <img src="{{ camara.src }}" alt="{{ camara.nombre }}" width="480">
        <p>Fecha y hora actuales: {{ fecha_actual|date:"d M Y H:i" }}</p>
    </div>
</div>
{% endblock %}

TeVeOApp/templates/pagina_configuracion.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Configuración del Usuario{% endblock %}
{% block subtitle %}la pagina de configuracion{% endblock %}

{% block content %}
<div class="container subtitulo">
    <h1>Configuración del Usuario</h1>

    <form method="post">
        {% csrf_token %}
        <div class="form-group">
            <label for="id_nombre_usuario">Nombre de Usuario:</label>
            {{ form.nombre_usuario }}
        </div>
        <div class="form-group">
            <label for="id_tipo_fuente">Tipo de Fuente:</label>
            {{ form.tipo_fuente }}
        </div>
        <div class="form-group">
            <label for="id_tamano_fuente">Tamaño de Fuente:</label>
            {{ form.tamano_fuente }}
        </div>
        <button type="submit" class="btn btn-primary">Guardar Configuración</button>
    </form>
</div>
{% endblock %}

TeVeOApp/templates/pagina_principal.html
{% extends "base.html" %}
{% load static %}

{% block title %}Página Principal{% endblock %}
{% block subtitle %}la Página Principal{% endblock %}

{% block content %}
<br><h2 class="subtitulo">Comentarios Recientes</h2>
<div class="comments">
    {% for comentario in comentario %}
        <br><br><h4 class="subtitulo">Cámara: <a href="{% url 'pagina_camara' comentario.camara.id_camara %}">{{ comentario.camara.nombre }}</a></h4>
        <div class="row border container-fluid justify-content-center">
            <div class="col-3">
                <img src="{% static 'imagen_comentarios/' %}{{ comentario.imagen_url }}" alt="Imagen de comentario no disponible" style="width: 100%; height: auto;">
            </div>
            <div class="col-6">
                <div class="row container-fluid justify-content-center">
                    <div class="card border-success mb-3 col-6">
                        <br><p class="card-text"><strong>Comentario:</strong> {{ comentario.texto }}</p><br>
                    </div>
                    <div class="col-6">
                        <p><strong>Fecha:</strong> {{ comentario.fecha }}</p>
                        <p><strong>Autor:</strong> {{ comentario.usuario.nombre_usuario }}</p>
                    </div>
                </div>
                <br><br><br>
            </div>

        </div>
    {% endfor %}
</div>

<div class="pagination justify-content-center">
    <span class="step-links">
        {% if comentario.has_previous %}
            <a href="?page=1">&laquo; primera</a>
            <a href="?page={{ comentario.previous_page_number }}">anterior</a>
        {% endif %}

        <span class="current">
            Página {{ comentario.number }} de {{ comentario.paginator.num_pages }}.
        </span>

        {% if comentario.has_next %}
            <a href="?page={{ comentario.next_page_number }}">siguiente</a>
            <a href="?page={{ comentario.paginator.num_pages }}">última &raquo;</a>
        {% endif %}
    </span>
</div>
{% endblock %}